/*--------------------------------------------------------------------------*/
/*  PLOT_ANSI: package for simple 2d X11 graphics                           */
/*                                                                          */
/*  (c) by A. Schmidt (1990-2004)                                           */
/*                                                                          */
/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License as published by */
/*     the Free Software Foundation; either version 2 of the License, or    */
/*     any later version.                                                   */
/*                                                                          */
/*     This program is distributed in the hope that it will be useful,      */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*     GNU General Public License for more details.                         */
/*--------------------------------------------------------------------------*/

/*  hwtest - sampe program for usage of HP widgets */

#include <stdio.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xw/Xw.h>
#include <X11/Xw/VPW.h>
#include <X11/Xw/Panel.h>
#include <X11/Xw/WorkSpace.h>
#include <X11/Xw/TitleBar.h>

#include <X11/Xdirect.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>



WindowHandle *wh;
Window WSwindow;
Display *WSdisplay;
Widget workspace;




static XrmOptionDescRec options[] = {
  {"-label", "*button.label", XrmoptionSepArg, NULL }
};

Syntax(call)
  char *call;
{
  fprintf(stderr,"Usage:%s\n",call);
}

static Widget titlebar = NULL;

Selected(w, client_data, call_data)
  Widget w; char *client_data, *call_data;
{
  static int count=0;
  static char string[100];
  static Arg TB_args[] = {
    {XtNstring, (XtArgVal) string } 
  };

  printf("Button %d was pressed.\n",*call_data);
  if (titlebar) {
    count++;
    sprintf(string,"< now, count=%d >", count);
    XtSetValues( titlebar, TB_args, 1 );
  }
    
}
 
KeyPressed(w, client_data, call_data)
  Widget w; char *client_data, *call_data;
{
  printf("Key Pressed\n");
}

Resized(w, client_data, call_data)
  Widget w; char *client_data, *call_data;
{
  printf("widget resized\n");
  zeichne(2);
}

Exposed(w, client_data, call_data)
  Widget w; char *client_data, *call_data;
{
  printf("widget exposed\n");
  zeichne(3);
}

Released(w, client_data, call_data)
  Widget w; char *client_data, *call_data;
{
  printf("widget released\n");
}



void main(argc,argv)
  unsigned int argc;
  char **argv;
{
  Widget toplevel, vpaned, panel;
  int zeichne(),wnnja();
  static XtCallbackRec cbKeyPressed[] = {
    {KeyPressed, NULL}, {NULL,NULL} };
  static XtCallbackRec cbSelected[] = {
    {Selected, NULL}, {NULL,NULL} };
  static XtCallbackRec cbReleased[] = {
    {Released, NULL}, {NULL,NULL} };
  static XtCallbackRec cbExposed[] = {
    {Exposed, NULL}, {NULL,NULL} };
  static XtCallbackRec cbResized[] = {
    {Resized, NULL}, {NULL,NULL} };

  static Arg WS_args[] = {
    {XtNwidth, (XtArgVal) 200 } ,
    {XtNheight, (XtArgVal) 200 } ,
    {XtNdepth, (XtArgVal) 24 } ,
    {XtNkeyDown, (XtArgVal) cbKeyPressed } ,
    {XtNexpose, (XtArgVal) cbExposed } ,
    {XtNresize, (XtArgVal) cbResized } ,
    {XtNselect, (XtArgVal) cbSelected } ,
    {XtNrelease, (XtArgVal) cbReleased } 
  };
  static Arg TB_args[] = {
    {XtNstring, (XtArgVal) "Title Bar of Work Space" } 
  };
  static Arg VP_args[] = {
    {XtNpadding, (XtArgVal) 2 } 
  };
  static Arg PA_args[] = {
    {XtNworkSpaceToSiblingPad, (XtArgVal) 20 } 
  };

  toplevel = XtInitialize( "main", "Demo", options, XtNumber(options),
                           &argc, argv );
  if (argc != 1) Syntax(argv[0]);



/*
  panel = 
    XtCreateManagedWidget( "Panel", XwpanelWidgetClass, toplevel,
                         PA_args, XtNumber(PA_args));
*/

  vpaned = 
    XtCreateManagedWidget( "VPaned", XwvPanedWidgetClass, toplevel,
                         VP_args, XtNumber(VP_args));

  titlebar = 
    XtCreateManagedWidget( "TitleBar", XwtitlebarWidgetClass, vpaned,
                         TB_args, XtNumber(TB_args));

  workspace = 
    XtCreateManagedWidget( "WorkSpace", XwworkSpaceWidgetClass, vpaned,
                         WS_args, XtNumber(WS_args));

  WSwindow = XtWindow(workspace);
  printf(" WSwindow = %8X = %d \n",WSwindow, WSwindow);

  XtRealizeWidget(toplevel);

  WSwindow = XtWindow(workspace);
  WSdisplay = XtDisplay(workspace);
  printf(" WSwindow = %8X = %d \n",WSwindow, WSwindow);
  printf(" WSdisplay = %8X = %d \n",WSdisplay, WSdisplay);

/*******
        printf("Versuche, Fenster fuer Grafik zu oeffnen\n");
        wh=XdCreateWindowHandle(WSdisplay,WSwindow);
        if(wh) printf("Habe Handle bekommen: %s %d\n",wh,&wh);

        printf("Versuche zu zeichnen\n");

        XdSetZFunction(wh,Z_FUNC_GE);

        XdSetDrawBuffer(wh,0,0);

        XdSetErrorHandler(wnnja);
********/

  XFlush(WSdisplay);
  
      /*  zeichne(1); */



  XtMainLoop();
}




int wnnja(dmy,dmy2)
int dmy,dmy2;
{
        printf("Reset 1:%d 2:%d\n",dmy,dmy2);
        XdReset(wh);
        return(0);
}



int zeichne(dmy)
int dmy;
{
        XdPoint drei[9];
        XdColor farb[3];
	int i,j;


        printf("Habe Zeichenbefehl bekommen %d\n",dmy);

   if (wh==NULL) {
        Window old_window = XtWindow(workspace);
        XVisualInfo visinf1,*visinf2;
        XSetWindowAttributes attis;
        unsigned long attimask;
        Colormap colourmap;
        int screen,class,nvisual;

        class=DirectColor;
        screen=DefaultScreen(WSdisplay);

        visinf1.screen=screen;
        visinf1.class=class;
        visinf2 = XGetVisualInfo(WSdisplay,VisualScreenMask|VisualClassMask,
                  &visinf1,&nvisual);

        colourmap=XTitanDefaultDirectColormap(WSdisplay,screen);

        attis.background_pixel = 0x404040;
        attis.border_pixel = 0xffffff;
        attis.colormap = colourmap;
        attis.override_redirect=1;
        attimask = CWBackPixel|CWBorderPixel|CWColormap|CWOverrideRedirect;

	XtCreateWindow(workspace, 0, visinf2->visual, attimask, &attis);

	WSwindow = XtWindow(workspace);
	printf("old_window= %8X, new window= %8X\n",old_window,WSwindow);
	if (old_window != WSwindow) {
	  printf(" destroy window %d\n",old_window);
	  XDestroyWindow(WSdisplay,old_window);
	}

        printf("Versuche, Fenster fuer Grafik zu oeffnen\n");
        wh=XdCreateWindowHandle(WSdisplay,WSwindow);
        if(wh) printf("Habe Handle bekommen: %s %d\n",wh,&wh);
	else return(-1);

        printf("Versuche zu zeichnen\n");

        XdSetZFunction(wh,Z_FUNC_GE);

        XdSetDrawBuffer(wh,0,0);

        XdSetErrorHandler(wnnja);

   }

        XdFillRectangle(wh, 0,0, 500,500, 0x000000, 0x0000, FillZColor);
        XdFlush(wh);

        farb[0].r = 1.0;
        farb[0].g = 0.0;
        farb[0].b = 0.0;
        drei[0].x = 000.0;
        drei[0].y = 000.0;
        drei[0].z = 005.0;
        drei[1].x = 500.0;
        drei[1].y = 000.0;
        drei[1].z = 005.0;
        drei[2].x = 000.0;
        drei[2].y = 300.0;
        drei[2].z = 005.0;

        farb[1].r = 0.0;
        farb[1].g = 1.0;
        farb[1].b = 0.0;
        drei[3].x = 000.0;
        drei[3].y = 500.0;
        drei[3].z = 002.0;
        drei[4].x = 500.0;
        drei[4].y = 500.0;
        drei[4].z = 002.0;
        drei[5].x = 000.0;
        drei[5].y = 100.0;
        drei[5].z = 002.0;
        farb[2].r = 0.0;
        farb[2].g = 0.0;
        farb[2].b = 1.0;
        drei[6].x = 500.0;
        drei[6].y = 400.0;
        drei[6].z = 003.0;
        drei[7].x = 500.0;
        drei[7].y = 100.0;
        drei[7].z = 003.0;
        drei[8].x = 000.0;
        drei[8].y = 250.0;
        drei[8].z = 003.0;
        XdSetBaseColor(wh,farb+1);
   
 drei[0].x =  10.0;
 drei[0].y =  10.0;
 drei[0].z =   1.0;

 drei[1].x =  10.0;
 drei[1].y = 450.0;
 drei[1].z =   1.0;

 drei[2].x = 250.0;
 drei[2].y = 450.0;
 drei[2].z =   1.0;
  
 XdDrawLine(wh,drei);

 XdDrawLineList(wh,drei,3); 


        XdFillTriangle(wh,drei+3);
        XdSetBaseColor(wh,farb);
        XdFillTriangle(wh,drei);
        XdSetBaseColor(wh,farb+2);
        XdFillTriangle(wh,drei+6);

/*
 for (i=1;i<11;i++) {
   drei[0].x =   10.0;
   drei[0].y = i*10.0;
   drei[0].z =   10.0;

   for (j=1;j<11;i++) {
     drei[1].x =  110.0;
     drei[1].y = j*10.0;
     drei[1].z =   20.0;

     XdDrawLine(wh,drei);
   }
 }
*/


        XdFlush(wh);
	XFlush(WSdisplay);
        return(1);
}

