#ifndef _CSOLVER_INFO_H_
#define _CSOLVER_INFO_H_

/*--------------------------------------------------------------------------*/
/*  library of Orthogonal Error Methods                                     */
/*                                                                          */
/*  most routines are the C-version of OFM-lib by Willy Doerfler            */
/*                                                                          */
/*  author: Kunibert G. Siebert                                             */
/*          Institut fuer Mathematik                                        */
/*          Universitaet Augsburg                                           */
/*          Universitaetsstr. 14                                            */
/*          D-86159 Augsburg, Germany                                       */
/*                                                                          */
/*          http://scicomp.math.uni-augsburg.de/Siebert/                    */
/*                                                                          */
/*--------------------------------------------------------------------------*/
/* (c) by K.G. Siebert (2000-2004)                                          */
/*                                                                          */
/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License as published by */
/*     the Free Software Foundation; either version 2 of the License, or    */
/*     any later version.                                                   */
/*                                                                          */
/*     This program is distributed in the hope that it will be useful,      */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*     GNU General Public License for more details.                         */
/*--------------------------------------------------------------------------*/

#include "oem.h"
#include "cblas.h"

#ifdef __cplusplus
extern "C" {
#endif

/*--------------------------------------------------------------------------*/
/*  functions for printing information (file info.c)                        */
/*--------------------------------------------------------------------------*/

void start_info(const char *, OEM_DATA *);
void break_info(const char *, OEM_DATA *, const char *, int, REAL, REAL *,
		WORKSPACE *);
int  solve_info(const char *, OEM_DATA *, int, REAL, REAL *, WORKSPACE *);

#define START_INFO(oem)  start_info(funcName, oem)
#define BREAK_INFO(oem,st,it,res,ores,ws)\
  break_info(funcName,oem,st,it,res,ores,ws)
#define SOLVE_INFO(oem,it,res,ores,ws) solve_info(funcName,oem,it,res,ores,ws)

WORKSPACE *check_workspace(const char *, const char *, int, size_t, 
			   WORKSPACE *);
void free_oem_workspace(WORKSPACE *ws, OEM_DATA *oem);
#define CHECK_WORKSPACE(size,ws)\
  check_workspace(funcName,__FILE__,__LINE__,size,ws)

#ifdef __cplusplus
}
#endif

#endif /* _CSOLVER_INFO_H_ */
